gi-gtk4-4.0.12: Gtk 4.x bindings

Copyright | Will Thompson and Iñaki García Etxebarria
License | LGPL-2.1
Maintainer | Iñaki García Etxebarria
Safe Haskell | None
Language | Haskell2010

GI.Gtk.Objects.Assistant

Contents

- Exported types
- Methods
  - addActionWidget
  - appendPage
  - commit
  - getCurrentPage
  - getNPages
  - getNthPage
  - getPage
  - getPageComplete
  - getPageTitle
  - getPageType
  - getPages
  - insertPage
  - new
  - nextPage
  - prependPage
  - previousPage
  - removeActionWidget
  - removePage
  - setCurrentPage
  - setForwardPageFunc
  - setPageComplete
  - setPageTitle
  - setPageType
  - updateButtonsState
- Properties
  - pages
  - useHeaderBar
- Signals
  - apply
  - cancel
  - close
  - escape
  - prepare

Description

`GtkAssistant` is used to represent a complex as a series of steps.

<picture> <source srcset="assistant-dark.png" media="(prefers-color-scheme: dark)"> <img alt="An example GtkAssistant" src="assistant.png"> </picture>

Each step consists of one or more pages. `GtkAssistant` guides the user through the pages, and controls the page flow to collect the data needed for the operation.

`GtkAssistant` handles which buttons to show and to make sensitive based on page sequence knowledge and the `AssistantPageType` of each page in addition to state information like the *completed* and *committed* page statuses.

If you have a case that doesn’t quite fit in `GtkAssistant`s way of handling buttons, you can use the `AssistantPageTypeCustom` page type and handle buttons yourself.

`GtkAssistant` maintains a `GtkAssistantPage` object for each added child, which holds additional per-child properties. You obtain the `GtkAssistantPage` for a child with `assistantGetPage`.

# GtkAssistant as GtkBuildable

The `GtkAssistant` implementation of the `GtkBuildable` interface exposes the `actionArea` as internal children with the name “action_area”.

To add pages to an assistant in `GtkBuilder`, simply add it as a child to the `GtkAssistant` object. If you need to set per-object properties, create a `GtkAssistantPage` object explicitly, and set the child widget as a property on it.

# CSS nodes

`GtkAssistant` has a single CSS node with the name window and style class .assistant.

Synopsis

- newtype Assistant = Assistant (ManagedPtr Assistant)
- class (GObject o, IsDescendantOf Assistant o) => IsAssistant o
- toAssistant :: (MonadIO m, IsAssistant o) => o -> m Assistant
- assistantAddActionWidget :: (HasCallStack, MonadIO m, IsAssistant a, IsWidget b) => a -> b -> m ()
- assistantAppendPage :: (HasCallStack, MonadIO m, IsAssistant a, IsWidget b) => a -> b -> m Int32
- assistantCommit :: (HasCallStack, MonadIO m, IsAssistant a) => a -> m ()
- assistantGetCurrentPage :: (HasCallStack, MonadIO m, IsAssistant a) => a -> m Int32
- assistantGetNPages :: (HasCallStack, MonadIO m, IsAssistant a) => a -> m Int32
- assistantGetNthPage :: (HasCallStack, MonadIO m, IsAssistant a) => a -> Int32 -> m (Maybe Widget)
- assistantGetPage :: (HasCallStack, MonadIO m, IsAssistant a, IsWidget b) => a -> b -> m AssistantPage
- assistantGetPageComplete :: (HasCallStack, MonadIO m, IsAssistant a, IsWidget b) => a -> b -> m Bool
- assistantGetPageTitle :: (HasCallStack, MonadIO m, IsAssistant a, IsWidget b) => a -> b -> m Text
- assistantGetPageType :: (HasCallStack, MonadIO m, IsAssistant a, IsWidget b) => a -> b -> m AssistantPageType
- assistantGetPages :: (HasCallStack, MonadIO m, IsAssistant a) => a -> m ListModel
- assistantInsertPage :: (HasCallStack, MonadIO m, IsAssistant a, IsWidget b) => a -> b -> Int32 -> m Int32
- assistantNew :: (HasCallStack, MonadIO m) => m Assistant
- assistantNextPage :: (HasCallStack, MonadIO m, IsAssistant a) => a -> m ()
- assistantPrependPage :: (HasCallStack, MonadIO m, IsAssistant a, IsWidget b) => a -> b -> m Int32
- assistantPreviousPage :: (HasCallStack, MonadIO m, IsAssistant a) => a -> m ()
- assistantRemoveActionWidget :: (HasCallStack, MonadIO m, IsAssistant a, IsWidget b) => a -> b -> m ()
- assistantRemovePage :: (HasCallStack, MonadIO m, IsAssistant a) => a -> Int32 -> m ()
- assistantSetCurrentPage :: (HasCallStack, MonadIO m, IsAssistant a) => a -> Int32 -> m ()
- assistantSetForwardPageFunc :: (HasCallStack, MonadIO m, IsAssistant a) => a -> Maybe AssistantPageFunc -> m ()
- assistantSetPageComplete :: (HasCallStack, MonadIO m, IsAssistant a, IsWidget b) => a -> b -> Bool -> m ()
- assistantSetPageTitle :: (HasCallStack, MonadIO m, IsAssistant a, IsWidget b) => a -> b -> Text -> m ()
- assistantSetPageType :: (HasCallStack, MonadIO m, IsAssistant a, IsWidget b) => a -> b -> AssistantPageType -> m ()
- assistantUpdateButtonsState :: (HasCallStack, MonadIO m, IsAssistant a) => a -> m ()
- getAssistantPages :: (MonadIO m, IsAssistant o) => o -> m (Maybe ListModel)
- constructAssistantUseHeaderBar :: (IsAssistant o, MonadIO m) => Int32 -> m (GValueConstruct o)
- getAssistantUseHeaderBar :: (MonadIO m, IsAssistant o) => o -> m Int32
- type AssistantApplyCallback = IO ()
- afterAssistantApply :: (IsAssistant a, MonadIO m) => a -> ((?self :: a) => AssistantApplyCallback) -> m SignalHandlerId
- onAssistantApply :: (IsAssistant a, MonadIO m) => a -> ((?self :: a) => AssistantApplyCallback) -> m SignalHandlerId
- type AssistantCancelCallback = IO ()
- afterAssistantCancel :: (IsAssistant a, MonadIO m) => a -> ((?self :: a) => AssistantCancelCallback) -> m SignalHandlerId
- onAssistantCancel :: (IsAssistant a, MonadIO m) => a -> ((?self :: a) => AssistantCancelCallback) -> m SignalHandlerId
- type AssistantCloseCallback = IO ()
- afterAssistantClose :: (IsAssistant a, MonadIO m) => a -> ((?self :: a) => AssistantCloseCallback) -> m SignalHandlerId
- onAssistantClose :: (IsAssistant a, MonadIO m) => a -> ((?self :: a) => AssistantCloseCallback) -> m SignalHandlerId
- type AssistantEscapeCallback = IO ()
- afterAssistantEscape :: (IsAssistant a, MonadIO m) => a -> ((?self :: a) => AssistantEscapeCallback) -> m SignalHandlerId
- onAssistantEscape :: (IsAssistant a, MonadIO m) => a -> ((?self :: a) => AssistantEscapeCallback) -> m SignalHandlerId
- type AssistantPrepareCallback = Widget -> IO ()
- afterAssistantPrepare :: (IsAssistant a, MonadIO m) => a -> ((?self :: a) => AssistantPrepareCallback) -> m SignalHandlerId
- onAssistantPrepare :: (IsAssistant a, MonadIO m) => a -> ((?self :: a) => AssistantPrepareCallback) -> m SignalHandlerId

# Exported types

newtype Assistant Source #

Memory-managed wrapper type.

Constructors

Assistant (ManagedPtr Assistant) |

#### Instances

Instances details

Eq Assistant Source # |
Instance details Defined in GI.Gtk.Objects.Assistant Methods (==) :: Assistant -> Assistant -> Bool Source # (/=) :: Assistant -> Assistant -> Bool Source #
GObject Assistant Source # |
Instance details Defined in GI.Gtk.Objects.Assistant
ManagedPtrNewtype Assistant Source # |
Instance details Defined in GI.Gtk.Objects.Assistant Methods toManagedPtr :: Assistant -> ManagedPtr Assistant Source #
TypedObject Assistant Source # |
Instance details Defined in GI.Gtk.Objects.Assistant Methods glibType :: IO GType Source #
HasParentTypes Assistant Source # |
Instance details Defined in GI.Gtk.Objects.Assistant
IsGValue (Maybe Assistant) Source # | Convert `Assistant` to and from `GValue`. See `toGValue` and `fromGValue`.
Instance details Defined in GI.Gtk.Objects.Assistant Methods gvalueGType_ :: IO GType Source # gvalueSet_ :: Ptr GValue -> Maybe Assistant -> IO () Source # gvalueGet_ :: Ptr GValue -> IO (Maybe Assistant) Source #
type ParentTypes Assistant Source # |
Instance details Defined in GI.Gtk.Objects.Assistant type ParentTypes Assistant = '[Window, Widget, Object, Accessible, Buildable, ConstraintTarget, Native, Root, ShortcutManager]

class (GObject o, IsDescendantOf Assistant o) => IsAssistant o Source #

Type class for types which can be safely cast to `Assistant`, for instance with `toAssistant`.

#### Instances

Instances details

(GObject o, IsDescendantOf Assistant o) => IsAssistant o Source # |
Instance details Defined in GI.Gtk.Objects.Assistant

toAssistant :: (MonadIO m, IsAssistant o) => o -> m Assistant Source #

Cast to `Assistant`, for types for which this is known to be safe. For general casts, use `castTo`.

# Methods

### Click to display all available methods, including inherited ones

Expand

#### Methods

actionSetEnabled, activate, activateAction, activateDefault, addActionWidget, addController, addCssClass, addMnemonicLabel, addTickCallback, allocate, announce, appendPage, bindProperty, bindPropertyFull, childFocus, close, commit, computeBounds, computeExpand, computePoint, computeTransform, contains, createPangoContext, createPangoLayout, destroy, disposeTemplate, dragCheckThreshold, errorBell, forceFloating, freezeNotify, fullscreen, fullscreenOnMonitor, getv, grabFocus, hasCssClass, hasDefault, hasFocus, hasGroup, hasVisibleFocus, hide, inDestruction, initTemplate, insertActionGroup, insertAfter, insertBefore, insertPage, isActive, isAncestor, isDrawable, isFloating, isFocus, isFullscreen, isMaximized, isSensitive, isSuspended, isVisible, keynavFailed, listMnemonicLabels, map, maximize, measure, minimize, mnemonicActivate, nextPage, notify, notifyByPspec, observeChildren, observeControllers, pick, prependPage, present, presentWithTime, previousPage, queueAllocate, queueDraw, queueResize, realize, ref, refSink, removeActionWidget, removeController, removeCssClass, removeMnemonicLabel, removePage, removeTickCallback, resetProperty, resetRelation, resetState, runDispose, shouldLayout, show, sizeAllocate, snapshotChild, stealData, stealQdata, thawNotify, translateCoordinates, triggerTooltipQuery, unfullscreen, unmap, unmaximize, unminimize, unparent, unrealize, unref, unsetStateFlags, updateButtonsState, updateNextAccessibleSibling, updatePlatformState, updateProperty, updateRelation, updateState, watchClosure.

#### Getters

getAccessibleId, getAccessibleParent, getAccessibleRole, getAllocatedBaseline, getAllocatedHeight, getAllocatedWidth, getAllocation, getAncestor, getApplication, getAtContext, getBaseline, getBounds, getBuildableId, getCanFocus, getCanTarget, getChild, getChildVisible, getClipboard, getColor, getCssClasses, getCssName, getCurrentPage, getCursor, getData, getDecorated, getDefaultSize, getDefaultWidget, getDeletable, getDestroyWithParent, getDirection, getDisplay, getFirstAccessibleChild, getFirstChild, getFocus, getFocusChild, getFocusOnClick, getFocusVisible, getFocusable, getFontMap, getFontOptions, getFrameClock, getGravity, getGroup, getHalign, getHandleMenubarAccel, getHasTooltip, getHeight, getHexpand, getHexpandSet, getHideOnClose, getIconName, getLastChild, getLayoutManager, getLimitEvents, getMapped, getMarginBottom, getMarginEnd, getMarginStart, getMarginTop, getMnemonicsVisible, getModal, getNPages, getName, getNative, getNextAccessibleSibling, getNextSibling, getNthPage, getOpacity, getOverflow, getPage, getPageComplete, getPageTitle, getPageType, getPages, getPangoContext, getParent, getPlatformState, getPreferredSize, getPrevSibling, getPrimaryClipboard, getProperty, getQdata, getRealized, getReceivesDefault, getRenderer, getRequestMode, getResizable, getRoot, getScaleFactor, getSensitive, getSettings, getSize, getSizeRequest, getStateFlags, getStyleContext, getSurface, getSurfaceTransform, getTemplateChild, getTitle, getTitlebar, getTooltipMarkup, getTooltipText, getTransientFor, getValign, getVexpand, getVexpandSet, getVisible, getWidth.

#### Setters

setAccessibleParent, setApplication, setCanFocus, setCanTarget, setChild, setChildVisible, setCssClasses, setCurrentPage, setCursor, setCursorFromName, setData, setDataFull, setDecorated, setDefaultSize, setDefaultWidget, setDeletable, setDestroyWithParent, setDirection, setDisplay, setFocus, setFocusChild, setFocusOnClick, setFocusVisible, setFocusable, setFontMap, setFontOptions, setForwardPageFunc, setGravity, setHalign, setHandleMenubarAccel, setHasTooltip, setHexpand, setHexpandSet, setHideOnClose, setIconName, setLayoutManager, setLimitEvents, setMarginBottom, setMarginEnd, setMarginStart, setMarginTop, setMnemonicsVisible, setModal, setName, setOpacity, setOverflow, setPageComplete, setPageTitle, setPageType, setParent, setProperty, setReceivesDefault, setResizable, setSensitive, setSizeRequest, setStartupId, setStateFlags, setTitle, setTitlebar, setTooltipMarkup, setTooltipText, setTransientFor, setValign, setVexpand, setVexpandSet, setVisible.

## addActionWidget

assistantAddActionWidget Source #

Arguments

:: (HasCallStack, MonadIO m, IsAssistant a, IsWidget b) |
=> a | `assistant`: a `GtkAssistant`
-> b | `child`: a `GtkWidget`
-> m () |

Deprecated: (Since version 4.10)This widget will be removed in GTK 5

Adds a widget to the action area of a `GtkAssistant`.

## appendPage

assistantAppendPage Source #

Arguments

:: (HasCallStack, MonadIO m, IsAssistant a, IsWidget b) |
=> a | `assistant`: a `GtkAssistant`
-> b | `page`: a `GtkWidget`
-> m Int32 | Returns: the index (starting at 0) of the inserted page

Deprecated: (Since version 4.10)This widget will be removed in GTK 5

Appends a page to the `assistant`.

## commit

assistantCommit Source #

Arguments

:: (HasCallStack, MonadIO m, IsAssistant a) |
=> a | `assistant`: a `GtkAssistant`
-> m () |

Deprecated: (Since version 4.10)This widget will be removed in GTK 5

Erases the visited page history.

GTK will then hide the back button on the current page, and removes the cancel button from subsequent pages.

Use this when the information provided up to the current page is hereafter deemed permanent and cannot be modified or undone. For example, showing a progress page to track a long-running, unreversible operation after the user has clicked apply on a confirmation page.

## getCurrentPage

assistantGetCurrentPage Source #

Arguments

:: (HasCallStack, MonadIO m, IsAssistant a) |
=> a | `assistant`: a `GtkAssistant`
-> m Int32 | Returns: The index (starting from 0) of the current page in the `assistant`, or -1 if the `assistant` has no pages, or no current page

Deprecated: (Since version 4.10)This widget will be removed in GTK 5

Returns the page number of the current page.

## getNPages

assistantGetNPages Source #

Arguments

:: (HasCallStack, MonadIO m, IsAssistant a) |
=> a | `assistant`: a `GtkAssistant`
-> m Int32 | Returns: the number of pages in the `assistant`

Deprecated: (Since version 4.10)This widget will be removed in GTK 5

Returns the number of pages in the `assistant`

## getNthPage

assistantGetNthPage Source #

Arguments

:: (HasCallStack, MonadIO m, IsAssistant a) |
=> a | `assistant`: a `GtkAssistant`
-> Int32 | `pageNum`: the index of a page in the `assistant`, or -1 to get the last page
-> m (Maybe Widget) | Returns: the child widget, or `Nothing` if `pageNum` is out of bounds

Deprecated: (Since version 4.10)This widget will be removed in GTK 5

Returns the child widget contained in page number `pageNum`.

## getPage

assistantGetPage Source #

Arguments

:: (HasCallStack, MonadIO m, IsAssistant a, IsWidget b) |
=> a | `assistant`: a `GtkAssistant`
-> b | `child`: a child of `assistant`
-> m AssistantPage | Returns: the `GtkAssistantPage` for `child`

Deprecated: (Since version 4.10)This widget will be removed in GTK 5

Returns the `GtkAssistantPage` object for `child`.

## getPageComplete

assistantGetPageComplete Source #

Arguments

:: (HasCallStack, MonadIO m, IsAssistant a, IsWidget b) |
=> a | `assistant`: a `GtkAssistant`
-> b | `page`: a page of `assistant`
-> m Bool | Returns: `True` if `page` is complete.

Deprecated: (Since version 4.10)This widget will be removed in GTK 5

Gets whether `page` is complete.

## getPageTitle

assistantGetPageTitle Source #

Arguments

:: (HasCallStack, MonadIO m, IsAssistant a, IsWidget b) |
=> a | `assistant`: a `GtkAssistant`
-> b | `page`: a page of `assistant`
-> m Text | Returns: the title for `page`

Deprecated: (Since version 4.10)This widget will be removed in GTK 5

Gets the title for `page`.

## getPageType

assistantGetPageType Source #

Arguments

:: (HasCallStack, MonadIO m, IsAssistant a, IsWidget b) |
=> a | `assistant`: a `GtkAssistant`
-> b | `page`: a page of `assistant`
-> m AssistantPageType | Returns: the page type of `page`

Deprecated: (Since version 4.10)This widget will be removed in GTK 5

Gets the page type of `page`.

## getPages

assistantGetPages Source #

Arguments

:: (HasCallStack, MonadIO m, IsAssistant a) |
=> a | `assistant`: a `GtkAssistant`
-> m ListModel | Returns: A list model of the pages.

Deprecated: (Since version 4.10)This widget will be removed in GTK 5

Gets a list model of the assistant pages.

## insertPage

assistantInsertPage Source #

Arguments

:: (HasCallStack, MonadIO m, IsAssistant a, IsWidget b) |
=> a | `assistant`: a `GtkAssistant`
-> b | `page`: a `GtkWidget`
-> Int32 | `position`: the index (starting at 0) at which to insert the page, or -1 to append the page to the `assistant`
-> m Int32 | Returns: the index (starting from 0) of the inserted page

Deprecated: (Since version 4.10)This widget will be removed in GTK 5

Inserts a page in the `assistant` at a given position.

## new

assistantNew Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> m Assistant | Returns: a newly created `GtkAssistant`

Deprecated: (Since version 4.10)This widget will be removed in GTK 5

Creates a new `GtkAssistant`.

## nextPage

assistantNextPage Source #

Arguments

:: (HasCallStack, MonadIO m, IsAssistant a) |
=> a | `assistant`: a `GtkAssistant`
-> m () |

Deprecated: (Since version 4.10)This widget will be removed in GTK 5

Navigate to the next page.

It is a programming error to call this function when there is no next page.

This function is for use when creating pages of the `AssistantPageTypeCustom` type.

## prependPage

assistantPrependPage Source #

Arguments

:: (HasCallStack, MonadIO m, IsAssistant a, IsWidget b) |
=> a | `assistant`: a `GtkAssistant`
-> b | `page`: a `GtkWidget`
-> m Int32 | Returns: the index (starting at 0) of the inserted page

Deprecated: (Since version 4.10)This widget will be removed in GTK 5

Prepends a page to the `assistant`.

## previousPage

assistantPreviousPage Source #

Arguments

:: (HasCallStack, MonadIO m, IsAssistant a) |
=> a | `assistant`: a `GtkAssistant`
-> m () |

Deprecated: (Since version 4.10)This widget will be removed in GTK 5

Navigate to the previous visited page.

It is a programming error to call this function when no previous page is available.

This function is for use when creating pages of the `AssistantPageTypeCustom` type.

## removeActionWidget

assistantRemoveActionWidget Source #

Arguments

:: (HasCallStack, MonadIO m, IsAssistant a, IsWidget b) |
=> a | `assistant`: a `GtkAssistant`
-> b | `child`: a `GtkWidget`
-> m () |

Deprecated: (Since version 4.10)This widget will be removed in GTK 5

Removes a widget from the action area of a `GtkAssistant`.

## removePage

assistantRemovePage Source #

Arguments

:: (HasCallStack, MonadIO m, IsAssistant a) |
=> a | `assistant`: a `GtkAssistant`
-> Int32 | `pageNum`: the index of a page in the `assistant`, or -1 to remove the last page
-> m () |

Deprecated: (Since version 4.10)This widget will be removed in GTK 5

Removes the `pageNum`’s page from `assistant`.

## setCurrentPage

assistantSetCurrentPage Source #

Arguments

:: (HasCallStack, MonadIO m, IsAssistant a) |
=> a | `assistant`: a `GtkAssistant`
-> Int32 | `pageNum`: index of the page to switch to, starting from 0. If negative, the last page will be used. If greater than the number of pages in the `assistant`, nothing will be done.
-> m () |

Deprecated: (Since version 4.10)This widget will be removed in GTK 5

Switches the page to `pageNum`.

Note that this will only be necessary in custom buttons, as the `assistant` flow can be set with `assistantSetForwardPageFunc`.

## setForwardPageFunc

assistantSetForwardPageFunc Source #

Arguments

:: (HasCallStack, MonadIO m, IsAssistant a) |
=> a | `assistant`: a `GtkAssistant`
-> Maybe AssistantPageFunc | `pageFunc`: the `GtkAssistantPageFunc`, or `Nothing` to use the default one
-> m () |

Deprecated: (Since version 4.10)This widget will be removed in GTK 5

Sets the page forwarding function to be `pageFunc`.

This function will be used to determine what will be the next page when the user presses the forward button. Setting `pageFunc` to `Nothing` will make the assistant to use the default forward function, which just goes to the next visible page.

## setPageComplete

assistantSetPageComplete Source #

Arguments

:: (HasCallStack, MonadIO m, IsAssistant a, IsWidget b) |
=> a | `assistant`: a `GtkAssistant`
-> b | `page`: a page of `assistant`
-> Bool | `complete`: the completeness status of the page
-> m () |

Deprecated: (Since version 4.10)This widget will be removed in GTK 5

Sets whether `page` contents are complete.

This will make `assistant` update the buttons state to be able to continue the task.

## setPageTitle

assistantSetPageTitle Source #

Arguments

:: (HasCallStack, MonadIO m, IsAssistant a, IsWidget b) |
=> a | `assistant`: a `GtkAssistant`
-> b | `page`: a page of `assistant`
-> Text | `title`: the new title for `page`
-> m () |

Deprecated: (Since version 4.10)This widget will be removed in GTK 5

Sets a title for `page`.

The title is displayed in the header area of the assistant when `page` is the current page.

## setPageType

assistantSetPageType Source #

Arguments

:: (HasCallStack, MonadIO m, IsAssistant a, IsWidget b) |
=> a | `assistant`: a `GtkAssistant`
-> b | `page`: a page of `assistant`
-> AssistantPageType | `type`: the new type for `page`
-> m () |

Deprecated: (Since version 4.10)This widget will be removed in GTK 5

Sets the page type for `page`.

The page type determines the page behavior in the `assistant`.

## updateButtonsState

assistantUpdateButtonsState Source #

Arguments

:: (HasCallStack, MonadIO m, IsAssistant a) |
=> a | `assistant`: a `GtkAssistant`
-> m () |

Deprecated: (Since version 4.10)This widget will be removed in GTK 5

Forces `assistant` to recompute the buttons state.

GTK automatically takes care of this in most situations, e.g. when the user goes to a different page, or when the visibility or completeness of a page changes.

One situation where it can be necessary to call this function is when changing a value on the current page affects the future page flow of the assistant.

# Properties

## pages

`GListModel` containing the pages.

getAssistantPages :: (MonadIO m, IsAssistant o) => o -> m (Maybe ListModel) Source #

Get the value of the “`pages`” property. When overloading is enabled, this is equivalent to

    get assistant #pages

## useHeaderBar

`True` if the assistant uses a `GtkHeaderBar` for action buttons instead of the action-area.

For technical reasons, this property is declared as an integer property, but you should only set it to `True` or `False`.

constructAssistantUseHeaderBar :: (IsAssistant o, MonadIO m) => Int32 -> m (GValueConstruct o) Source #

Construct a `GValueConstruct` with valid value for the “`use-header-bar`” property. This is rarely needed directly, but it is used by `new`.

getAssistantUseHeaderBar :: (MonadIO m, IsAssistant o) => o -> m Int32 Source #

Get the value of the “`use-header-bar`” property. When overloading is enabled, this is equivalent to

    get assistant #useHeaderBar

# Signals

## apply

type AssistantApplyCallback = IO () Source #

Deprecated: (Since version 4.10)This widget will be removed in GTK 5

Emitted when the apply button is clicked.

The default behavior of the `GtkAssistant` is to switch to the page after the current page, unless the current page is the last one.

A handler for the apply signal should carry out the actions for which the wizard has collected data. If the action takes a long time to complete, you might consider putting a page of type `AssistantPageTypeProgress` after the confirmation page and handle this operation within the Assistant::prepare signal of the progress page.

afterAssistantApply :: (IsAssistant a, MonadIO m) => a -> ((?self :: a) => AssistantApplyCallback) -> m SignalHandlerId Source #

Connect a signal handler for the apply signal, to be run after the default handler. When overloading is enabled, this is equivalent to

    after assistant #apply callback

By default the object invoking the signal is not passed to the callback. If you need to access it, you can use the implit `?self` parameter. Note that this requires activating the `ImplicitParams` GHC extension.

onAssistantApply :: (IsAssistant a, MonadIO m) => a -> ((?self :: a) => AssistantApplyCallback) -> m SignalHandlerId Source #

Connect a signal handler for the apply signal, to be run before the default handler. When overloading is enabled, this is equivalent to

    on assistant #apply callback

## cancel

type AssistantCancelCallback = IO () Source #

Deprecated: (Since version 4.10)This widget will be removed in GTK 5

Emitted when then the cancel button is clicked.

afterAssistantCancel :: (IsAssistant a, MonadIO m) => a -> ((?self :: a) => AssistantCancelCallback) -> m SignalHandlerId Source #

Connect a signal handler for the cancel signal, to be run after the default handler. When overloading is enabled, this is equivalent to

    after assistant #cancel callback

By default the object invoking the signal is not passed to the callback. If you need to access it, you can use the implit `?self` parameter. Note that this requires activating the `ImplicitParams` GHC extension.

onAssistantCancel :: (IsAssistant a, MonadIO m) => a -> ((?self :: a) => AssistantCancelCallback) -> m SignalHandlerId Source #

Connect a signal handler for the cancel signal, to be run before the default handler. When overloading is enabled, this is equivalent to

    on assistant #cancel callback

## close

type AssistantCloseCallback = IO () Source #

Deprecated: (Since version 4.10)This widget will be removed in GTK 5

Emitted either when the close button of a summary page is clicked, or when the apply button in the last page in the flow (of type `AssistantPageTypeConfirm`) is clicked.

afterAssistantClose :: (IsAssistant a, MonadIO m) => a -> ((?self :: a) => AssistantCloseCallback) -> m SignalHandlerId Source #

Connect a signal handler for the close signal, to be run after the default handler. When overloading is enabled, this is equivalent to

    after assistant #close callback

By default the object invoking the signal is not passed to the callback. If you need to access it, you can use the implit `?self` parameter. Note that this requires activating the `ImplicitParams` GHC extension.

onAssistantClose :: (IsAssistant a, MonadIO m) => a -> ((?self :: a) => AssistantCloseCallback) -> m SignalHandlerId Source #

Connect a signal handler for the close signal, to be run before the default handler. When overloading is enabled, this is equivalent to

    on assistant #close callback

## escape

type AssistantEscapeCallback = IO () Source #

Deprecated: (Since version 4.10)This widget will be removed in GTK 5

The action signal for the Escape binding.

afterAssistantEscape :: (IsAssistant a, MonadIO m) => a -> ((?self :: a) => AssistantEscapeCallback) -> m SignalHandlerId Source #

Connect a signal handler for the escape signal, to be run after the default handler. When overloading is enabled, this is equivalent to

    after assistant #escape callback

By default the object invoking the signal is not passed to the callback. If you need to access it, you can use the implit `?self` parameter. Note that this requires activating the `ImplicitParams` GHC extension.

onAssistantEscape :: (IsAssistant a, MonadIO m) => a -> ((?self :: a) => AssistantEscapeCallback) -> m SignalHandlerId Source #

Connect a signal handler for the escape signal, to be run before the default handler. When overloading is enabled, this is equivalent to

    on assistant #escape callback

## prepare

type AssistantPrepareCallback Source #

Arguments

= Widget | `page`: the current page
-> IO () |

Deprecated: (Since version 4.10)This widget will be removed in GTK 5

Emitted when a new page is set as the assistant's current page, before making the new page visible.

A handler for this signal can do any preparations which are necessary before showing `page`.

afterAssistantPrepare :: (IsAssistant a, MonadIO m) => a -> ((?self :: a) => AssistantPrepareCallback) -> m SignalHandlerId Source #

Connect a signal handler for the prepare signal, to be run after the default handler. When overloading is enabled, this is equivalent to

    after assistant #prepare callback

By default the object invoking the signal is not passed to the callback. If you need to access it, you can use the implit `?self` parameter. Note that this requires activating the `ImplicitParams` GHC extension.

onAssistantPrepare :: (IsAssistant a, MonadIO m) => a -> ((?self :: a) => AssistantPrepareCallback) -> m SignalHandlerId Source #

Connect a signal handler for the prepare signal, to be run before the default handler. When overloading is enabled, this is equivalent to

    on assistant #prepare callback